config/routes.rb
Rails.application.routes.draw do
  

  resources :transactions
  resources :supplies
  resources :products
  resources :distributors
  resources :reports, only: [:index]
  devise_for :users, :path_prefix => 'my', controllers: { sessions: 'users/sessions' }
  resources :users
  get 'users/sign_in' => 'users/sessions#new'

  get '/', to: 'home#index'

  

end

app/models/supply.rb
class Supply < ActiveRecord::Base
  belongs_to :distributor
  belongs_to :product

  validates_presence_of :distributor_id, :product_id 
end

app/controllers/supplies_controller.rb
class SuppliesController < ApplicationController
  before_action :set_supply, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!


  # GET /supplies
  # GET /supplies.json
  def index
    @supplies = Supply.all
  end

  # GET /supplies/1
  # GET /supplies/1.json
  def show
  end

  # GET /supplies/new
  def new
    @supply = Supply.new
    @products = Product.order('name asc').all
  end

  # GET /supplies/1/edit
  def edit
  end

  # POST /supplies
  # POST /supplies.json
  def create
    @products = Product.all
    @supply = Supply.new(supply_params)
    @product = Product.find(supply_params[:product_id])
    @supply.distributor_id = @product.distributor.id
    total_product = @product.available_product.to_i + @supply.total.to_i

    respond_to do |format|
      if @supply.save && @product.update(available_product: total_product)
        format.html { redirect_to supplies_url, notice: 'Supply was successfully created.' }
        format.json { render :show, status: :created, location: @supply }
      else
        format.html { render :new }
        format.json { render json: @supply.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /supplies/1
  # PATCH/PUT /supplies/1.json
  def update
    respond_to do |format|
      if @supply.update(supply_params)
        format.html { redirect_to supplies_url, notice: 'Supply was successfully updated.' }
        format.json { render :show, status: :ok, location: @supply }
      else
        format.html { render :edit }
        format.json { render json: @supply.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /supplies/1
  # DELETE /supplies/1.json
  def destroy
    @product = Product.find(@supply.product.id)
    total_product = @product.available_product - @supply.total.to_i

    @supply.destroy && @product.update(available_product: total_product)
    respond_to do |format|
      format.html { redirect_to supplies_url, notice: 'Supply was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_supply
      @supply = Supply.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def supply_params
      params.require(:supply).permit(:distributor_id, :product_id, :total)
    end
end

app/helpers/supplies_helper.rb
module SuppliesHelper
end

app/views/supplies/_form.html.erb
<!-- Main Content -->
<div class="container-fluid">
    <div class="side-body">
        <div class="page-title">
            <span class="title">Input Supply Barang</span>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-body">
                      <%= form_for(@supply) do |form| %>
                      <% if @supply.errors.any? %>
                        <div class="alert fresh-color alert-danger" role="alert">
                          <ul>
                            <% @supply.errors.full_messages.each do |message| %>
                            <li>
                              <strong><%= message %></strong>
                            </li>
                            <% end %>
                          </ul>
                        </div>
                        <% end %>
                        <div class="sub-title">Barang</div>
                        <div>
                         <%= form.select :product_id, options_for_select(@products.map{ |c| ["#{c.name} - #{c.size} - #{c.type_product}", c.id] }, selected_key = form.object.product_id), {}, {:class => "form-control"} %>
                        </div>
                        <div for="name" class="sub-title">total</div>
                        <div>
                            <%= form.number_field :total, class: 'form-control', placeholder: 'total' %>
                        </div>
                        <%= link_to 'Back', supplies_path, class: "btn btn-sm btn-default" %>
                        <button type="submit" class="btn btn-sm btn-info">Submit</button>
                      <% end %>
                    </div>
                </div>
            </div>
        </div>
    </div>

app/views/supplies/edit.html.erb
<%= render 'form' %>

<%= link_to 'Show', @supply %> |
<%= link_to 'Back', supplies_path %>

app/views/supplies/index.html.erb
<!-- Main Content -->
<div class="container-fluid">
    <div class="side-body">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <div class="card-title">
                        <div class="title">Supply Barang</div>
                        </div>
                        <div class="pull-right card-action">
                          <%= button_to "Input Supply Barang", new_supply_path, class: 'btn btn-info', method: 'get' %>
                        </div>
                    </div>
                    <div class="card-body">
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th bgcolor="#9adbf9">Distributor</th>
                                    <th bgcolor="#9adbf9">Nama Barang</th>
                                    <th bgcolor="#9adbf9">Jenis Barang</th>
                                    <th bgcolor="#9adbf9">Ukuran Barang</th>
                                    <th bgcolor="#9adbf9">Total</th>
                                    <th bgcolor="#9adbf9">Tanggal Masuk</th>
                                    <th colspan="1">Options</th>
                                </tr>
                            </thead>
                            <tbody>
                                <% @supplies.each do |supply| %>
                                <tr>
                                  <td><%= supply.distributor.name %></td>
                                  <td><%= supply.product.name %></td>
                                  <td><%= supply.product.type_product %></td>
                                  <td><%= supply.product.size %></td>
                                  <td><%= supply.total %></td>
                                  <td><%= supply.created_at.strftime('%d-%m-%Y %H:%M') %></td>
                                  <td><%= link_to 'Destroy', supply, method: :delete, data: { confirm: 'Are you sure?' } %></td>
                                </tr>
                              <% end %>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

app/views/supplies/new.html.erb
<%= render 'form' %>

<%= link_to 'Back', supplies_path %>

app/views/supplies/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Distributor:</strong>
  <%= @supply.distributor_id %>
</p>

<p>
  <strong>Product:</strong>
  <%= @supply.product_id %>
</p>

<p>
  <strong>Total:</strong>
  <%= @supply.total %>
</p>

<%= link_to 'Edit', edit_supply_path(@supply) %> |
<%= link_to 'Back', supplies_path %>